; Dbut du script-fu Typography_in_Gimp_By_GimpKnowHow_Gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Logos > Typography in Gimp By GimpKnowHow
;               File > Create > Logos > Typography in Gimp By GimpKnowHow
;
;                __________________________________________________________
; 
;
; script-fu inspir du didacticiel vido : http://www.youtube.com/watch?v=YiIzrEVchhw&feature=related
;
; Merci  GimpKnowHow, l'auteur.
;
;
;
; Licence GNU/GPL
;
; --------------------------------------------------------------------
; dit avec Notepad++    http://notepad-plus-plus.org/
;
; version 1.0 par samj (  http://www.aljacom.com/~gimp       http://samjcreations.blogspot.com  ) 18 juin 2012
;
;
;
; --------------------------------------------------------------------
;
;
; Remarques :
;             - Respecter le nombre de caractres pour ne pas avoir d'erreurs.
;             - Pour avoir uniquement un texte pench selon la diagonale, conserver uniquement le calque "calque_fond"
;             - Il est possible d'obtenir de nombreux autres effets en agissant sur les calques et les chemins.








(define (
				Typography_in_Gimp_By_GimpKnowHow
				Texte_du_fond
				Police_fond
				Couleur_encre_fond
				Espacement_texte_fond
				Texte_Logo
				Police_logo
				Couleur_encre_logo
				Taille_Police_logo
				Texte_signature_gauche
				Police_signature_gauche
				Couleur_encre_signature_gauche
				Texte_signature_droite
				Police_signature_droite
				Couleur_encre_signature_droite
				Couleur_Soulignement_logo_haut_gauche
				Couleur_Soulignement_logo_bas_droit
				Signatures
				flatten

		)
		
	(let*
		(
			; affectation des variables		
	
			; mmoriser les couleurs PP et AP
			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			
			; mmoriser brosse
			(old-brush (car (gimp-context-get-brush)))	

			; mmoriser interpolation
			(old_interpolation (car (gimp-context-get-interpolation)))
			
			; Couleur_fond
			(Couleur_fond '(0 0 0))
			
			; caractristiques de la surface occupe par le texte du logo
			(fond_logo (gimp-text-get-extents-fontname Texte_Logo Taille_Police_logo 0 Police_logo))
			
			; largeur du logo
			(width_logo (car fond_logo))
			
			; hauteur du logo
			(height_logo (cadr fond_logo))
			
			; largeur de l'image
			(width_image (round (* width_logo 2.1)))
			
			; hauteur image
			(height_image (round (* height_logo 3.75)))
			
			; crer une nouvelle image rgb qui sera renseigne plus loin selon les dimensions des signatures
			;(img (car (gimp-image-new width_image height_image 0)))
			(img)

			; taille de la police du fond
			(Taille_Police_fond (round (+ 7 (* Taille_Police_logo 0.07)))) ; 0.07 pour 21 pixels pour logo 200

			; taille de la police signature gauche
			(Taille_Police_signature_gauche (round (* Taille_Police_logo 0.6))) ; 0.225 pour 45  pixels pour logo 200
			
			; taille de la police signature droite
			(Taille_Police_signature_droite (round (* Taille_Police_logo 0.6))) ; 0.225 pour 45  pixels pour logo 200

			; caractristiques de la surface occupe par la signature gauche
			(fond_texte_signature_gauche (gimp-text-get-extents-fontname Texte_signature_gauche Taille_Police_signature_gauche 0 Police_signature_gauche))

			; largeur signature gauche
			(width_signature_gauche (car fond_texte_signature_gauche))
			
			; hauteur signature gauche
			(height_signature_gauche (cadr fond_texte_signature_gauche))

			; caractristiques de la surface occupe par la signature droite
			(fond_texte_signature_droite (gimp-text-get-extents-fontname Texte_signature_droite Taille_Police_signature_droite 0 Police_signature_droite))

			; largeur signature droite
			(width_signature_droite (car fond_texte_signature_droite))
			
			; hauteur signature droite
			(height_signature_droite (cadr fond_texte_signature_droite))


			; largeur totale des 2 signatures avec le dcalage  droite
			(width_total_signatures (+ (+ width_signature_gauche width_signature_droite) (round (* width_logo 0.2))))

			; calque_fond
			(calque_fond)
			
			; dimensions du calque de fond (largeur=hauteur)
			(dimensions_du_calque_de_fond)
			
			; angle rotation du calque de fond pour mettre en // avec diagonale de l'image
			(sinus_angle_rotation_du_calque_de_fond)
			(angle_rotation_du_calque_de_fond)
			(angle_rotation_du_calque_de_fond_en_degres)

			; calque_motif_texte_fond
			(calque_motif_texte_fond)

			; caractristiques de la surface occupe par le motif pour crer le texte du fond
			(fond_motif_texte (gimp-text-get-extents-fontname Texte_du_fond Taille_Police_fond 0 Police_fond))
			
			; largeur du motif_texte
			(width_motif_texte (car fond_motif_texte))
			
			; hauteur du motif_texte
			(height_motif_texte (* Espacement_texte_fond (cadr fond_motif_texte)))
			
			; crer une image pour le motif
			(img_motif_texte (car (gimp-image-new width_motif_texte (round (* height_motif_texte 1.05)) 0)))
			
			; calque_motif_texte
			(calque_motif_texte)
			
			; Increment_Y  pour boucle des dcalages du motif en texte
			(Increment_Y 0)
			
			; valeur alatoire dcalage
			(Valeur_aleatoire_decalage)
			
			; calque_couleur_fond
			(calque_couleur_fond)
			
			; calque_coins
			(calque_coins)
			
			; calque_texte_principal
			(calque_texte_principal)
			
			; calque_soulignement_haut_gauche
			(calque_soulignement_haut_gauche)
			
			; calque_soulignement_bas_droite
			(calque_soulignement_bas_droite)
			
			; dfinition des "array"
			(*array_4_points* (cons-array 8 'double)) ; dformation
			(*array2_4_points* (cons-array 8 'double)) ; soulignement haut gauche
			(*array3_4_points* (cons-array 8 'double)) ; soulignement bas droite
			
			; calque_signature_gauche
			(calque_signature_gauche)
			
			; calque_signature_droite
			(calque_signature_droite)
			
			
			
			
		)
		
		
		
		
		
			
		
		

	; vrifications
;	(gimp-message "Largeur image avant correction")			
;	(gimp-message (number->string width_image))	
		
	;; vrifier que les 2 signatures peuvent rentrer dans l'image
	(if
		(> width_total_signatures width_image)
			(set! width_image width_total_signatures)
	)		

	; dterminer la dimension du calque de fond qui pivotera
	(set! dimensions_du_calque_de_fond   (round (sqrt (+ (* width_image width_image)   (* height_image height_image))))   )	
	
	; sinus de l'angle de pivot
	(set! sinus_angle_rotation_du_calque_de_fond (/ height_image dimensions_du_calque_de_fond) )
	
	; angle de rotation calque de fond en radians et en degrs
	(set! angle_rotation_du_calque_de_fond (asin sinus_angle_rotation_du_calque_de_fond) )
	(set! angle_rotation_du_calque_de_fond_en_degres   (* 180 (/ angle_rotation_du_calque_de_fond 3.141592654)) )
	
	; vrifications
;	(gimp-message "Largeur image suite correction")			
;	(gimp-message (number->string width_image))	
;	(gimp-message "Hauteur image")			
;	(gimp-message (number->string height_image))		
;	(gimp-message "Largeur logo")			
;	(gimp-message (number->string width_logo))	
;	(gimp-message "Hauteur logo")			
;	(gimp-message (number->string height_logo))	
;	(gimp-message "Taille_Police_fond")			
;	(gimp-message (number->string Taille_Police_fond))		
;	(gimp-message "Taille_Police_signature_gauche")			
;	(gimp-message (number->string Taille_Police_signature_gauche))		
;	(gimp-message "Taille_Police_signature_droite")			
;	(gimp-message (number->string Taille_Police_signature_droite))	
;	(gimp-message "width_signature_gauche")			
;	(gimp-message (number->string width_signature_gauche))
;	(gimp-message "height_signature_gauche")			
;	(gimp-message (number->string height_signature_gauche))
;	(gimp-message "width_signature_droite")			
;	(gimp-message (number->string width_signature_droite))
;	(gimp-message "height_signature_droite")			
;	(gimp-message (number->string height_signature_droite))
;	(gimp-message "width_total_signatures")			
;	(gimp-message (number->string width_total_signatures))
;	(gimp-message "dimensions_du_calque_de_fond")			
;	(gimp-message (number->string dimensions_du_calque_de_fond))
;	(gimp-message "sinus_angle_rotation_du_calque_de_fond")			
;	(gimp-message (number->string sinus_angle_rotation_du_calque_de_fond))
;	(gimp-message "angle_rotation_du_calque_de_fond")			
;	(gimp-message (number->string angle_rotation_du_calque_de_fond))	
;	(gimp-message "angle_rotation_du_calque_de_fond_en_degres")			
;	(gimp-message (number->string angle_rotation_du_calque_de_fond_en_degres))
;	(gimp-message "width_motif_texte")			
;	(gimp-message (number->string width_motif_texte))	
;	(gimp-message "height_motif_texte")			
;	(gimp-message (number->string height_motif_texte))




;; Crer l'image du motif ( img_motif_texte ) ***************************************************************************

	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_encre_fond)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background Couleur_fond)

	; crer le calque calque_motif_texte
	;                  (gimp-text-fontname image drawable x y text border antialias size size-type fontname)
	(set! calque_motif_texte (car (gimp-text-fontname img_motif_texte -1 0 (round (* height_motif_texte 0.025)) Texte_du_fond 0 TRUE Taille_Police_fond 0 Police_fond)))
	
	; donner un nom au calque
	(gimp-item-set-name calque_motif_texte "calque_motif_texte")
	
	; aplatir l'image
	(gimp-image-flatten img_motif_texte)

	; ne rien slectionner
	(gimp-selection-none img_motif_texte)	

	; copier le motif
	(gimp-edit-copy-visible img_motif_texte)
	
	; astuce de RobA  http://www.gimpchat.com/viewtopic.php?f=8&t=1221&start=40 pour que le presse-papiers devienne le motif sans avoir  choisir le nom qui varie selon les langues de Gimp
	(gimp-context-set-pattern (list-ref (cadr (gimp-patterns-get-list "")) 0)) ; set patten to clipboard (first in list)

	; afficher l'image pour tests
	;(gimp-display-new img_motif_texte)





;; Crer l'image principale ( img ) *************************************************************************************

	; dterminer la nouvelle dimension du calque de fond qui pivotera en tenant compte des motifs en texte pour crer des dcalages 
	(set! dimensions_du_calque_de_fond   (+ dimensions_du_calque_de_fond (* 2 width_motif_texte))   )		
		
	; crer une nouvelle image rgb
	; (set! img (car (gimp-image-new width_image height_image 0)))
	(set! img (car (gimp-image-new dimensions_du_calque_de_fond dimensions_du_calque_de_fond 0)))
		
	;; Start undo group.
	(gimp-image-undo-group-start img)			
		
	; crer calque_fond
	(set! calque_fond (car (gimp-layer-new img dimensions_du_calque_de_fond dimensions_du_calque_de_fond 1 "calque_fond" 100 0)))	
	
	; ajouter le calque calque_fond
	(gimp-image-insert-layer img calque_fond 0 -1)	

	; crer une slection rectangulaire
	(gimp-image-select-rectangle
		img								; image 
		0								; operation 
		0								; x 
		0								; y 
		dimensions_du_calque_de_fond	; width 
		dimensions_du_calque_de_fond	; height
	)

	; remplir la slection de motif	
	(gimp-bucket-fill 
		calque_fond						; drawable 
		2								; fill-mode 
		0								; paint-mode 
		100								; opacity 
		0								; threshold 
		TRUE							; sample-merged 
		0								; x 
		0								; y
	)

	; effectuer des dcalages des textes	
	(while (< Increment_Y dimensions_du_calque_de_fond)

		; (gimp-message (number->string Increment_Y))
		
		; nouveau dcalage alatoire
		(set! Valeur_aleatoire_decalage (round (random width_motif_texte)) )

		; (gimp-message (number->string Valeur_aleatoire_decalage))
		
		; crer une nouvelle slection rectangulaire
		(gimp-image-select-rectangle
			img									; image 
			0									; operation 
			Valeur_aleatoire_decalage			; x 
			Increment_Y							; y 
			(- dimensions_du_calque_de_fond Valeur_aleatoire_decalage)		; width 
			(round (* height_motif_texte 1.05))	; height
		)		
		
		; copier
		(gimp-edit-copy calque_fond)
		
		; crer une slection rectangulaire
		(gimp-image-select-rectangle
			img									; image 
			0									; operation 
			0									; x 
			Increment_Y							; y 
			(- dimensions_du_calque_de_fond Valeur_aleatoire_decalage)		; width 
			(round (* height_motif_texte 1.05))	; height
		)		
		
		; coller et ancrer
		(gimp-floating-sel-anchor (car (gimp-edit-paste calque_fond FALSE)))

	
		; nouvelle valeur de Y
		(set! Increment_Y (+ Increment_Y (round (* height_motif_texte 1.05))) )
		
	)	



	; interpolation bi-cubique
	(gimp-context-set-interpolation 2)
		
	; rotation
	(gimp-item-transform-rotate 
		calque_fond									; item 
		angle_rotation_du_calque_de_fond			; angle 
		TRUE										; auto-center 
		(round (/  dimensions_du_calque_de_fond 2))	; center-x 
		(round (/  dimensions_du_calque_de_fond 2))	; center-y
	)

	
	; dcoupage
	(gimp-image-crop 
		img													; image 
		width_image											; new-width 
		height_image										; new-height 
		(/ (- dimensions_du_calque_de_fond width_image) 2)	; offx 
		(/ (- dimensions_du_calque_de_fond height_image) 2)	; offy
	)

	; ne rien slectionner
;	(gimp-selection-none img)	
	
	; slection de la couleur de fond
;	(gimp-image-select-color img 0 calque_fond Couleur_fond)
	
	; inverser la slection
;	(gimp-selection-invert img)
	
	; sauvegarder cette slection dans un chemin
;	(plug-in-sel2path 1 img calque_fond)
	
	; donner un nom au chemin
;	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "Texte_fond")	

	; ne rien slectionner
	(gimp-selection-none img)
	
	
	
	
	
; calque calque_coins *******************************************************************************
	


	; crer calque calque_coins
	(set! calque_coins (car (gimp-layer-new img width_image height_image 1 "calque_coins" 100 0)))	

	; ajouter le calque calque_coins
	(gimp-image-insert-layer img calque_coins 0 -1)		
	
	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_encre_fond)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background Couleur_fond)
	
	; slection rectangle arrondi
	(gimp-image-select-round-rectangle 
		img									; image 
		0									; operation 
		0									; x 
		0									; y 
		width_image							; width 
		height_image						; height 
		(round (* height_image 0.4))		; corner-radius-x 
		(round (* height_image 0.4))		; corner-radius-y
	)
	
	; dformation de la slection
	(script-fu-distress-selection 
		img 
		calque_coins 
		(* (+ (rand 15) 1) 
		(+ (rand 15) 1))
		(/ height_image 25) 
		4 
		2 
		TRUE 
		TRUE
	)	
	
	; inverser la slection
	(gimp-selection-invert img)
	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img calque_coins)
	
	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "calque_coins")
	
	; remplir la slection de couleur AP	
	(gimp-bucket-fill 
		calque_coins					; drawable 
		1								; fill-mode 
		0								; paint-mode 
		100								; opacity 
		0								; threshold 
		TRUE							; sample-merged 
		0								; x 
		0								; y
	)	

	; ne rien slectionner
	(gimp-selection-none img)	
	
	; appliquer un flou
	(plug-in-gauss 1 img calque_coins (round (/ height_image 5)) (round (/ height_image 5)) 1)
	
	



; calque calque_texte_principal *******************************************************************************


	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_encre_logo)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background Couleur_fond)

	; crer le calque calque_texte_principal
	;                  (gimp-text-fontname image drawable x y text border antialias size size-type fontname)
	(set! calque_texte_principal (car (gimp-text-fontname img -1 (round (* width_logo 0.4)) height_logo Texte_Logo 0 TRUE Taille_Police_logo 0 Police_logo)))
	
	; donner un nom au calque
	(gimp-item-set-name calque_texte_principal "calque_texte_principal")
	
	; slectionner le texte
	(gimp-image-select-item img 0 calque_texte_principal)
	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img calque_texte_principal)
	
	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "Texte_avant_deformation")

	; ne rien slectionner
	(gimp-selection-none img)	
	
	; perspective
	(gimp-item-transform-perspective 
		calque_texte_principal						; item 
		(round (* width_logo 0.4))					; x0 
		height_logo									; y0 
		(round (- width_image (/ width_logo 2)))	; x1 
		(round (/ height_logo 4))					; y1 
		(round (* width_logo 0.3))					; x2 
		(* height_logo 2.2)							; y2 
		(+ (round (* width_logo 0.4)) width_logo)	; x3 
		(+ height_logo height_logo)					; y3
	)

	; slectionner le texte
	(gimp-image-select-item img 0 calque_texte_principal)
	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img calque_texte_principal)
	
	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "Texte")	
	
	
	; mode dodge
	(gimp-layer-set-mode calque_texte_principal 16)
	
	; opacit du calque
	(gimp-layer-set-opacity calque_texte_principal 100)

	; points slection
	(aset *array_4_points* 0 (round (* width_logo 0.4)))					; x0
	(aset *array_4_points* 1 height_logo)									; y0
	(aset *array_4_points* 2 (round (- width_image (/ width_logo 2))))		; x1
	(aset *array_4_points* 3 (round (/ height_logo 4)))						; y1		
	(aset *array_4_points* 4 (+ (round (* width_logo 0.4)) width_logo))		; x2  inversion par rapport  perspective entre x2 et x3
	(aset *array_4_points* 5 (+ height_logo height_logo))					; y2  inversion par rapport  perspective entre y2 et y3
	(aset *array_4_points* 6 (round (* width_logo 0.3)))					; x3  inversion par rapport  perspective entre x2 et x3
	(aset *array_4_points* 7 (* height_logo 2.2))							; y3  inversion par rapport  perspective entre y2 et y3	
	
	; slection
	(gimp-free-select 
		img									; image 
		8									; num-segs 
		*array_4_points*				; segs 
		0									; operation 
		TRUE								; antialias 
		TRUE								; feather 
		1									; feather-radius
	)	

	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img calque_coins)
	
	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "deformation texte")	

	; ne rien slectionner
	(gimp-selection-none img)
	
	
	
	
	
; calque calque_soulignement_haut_gauche *******************************************************************************
	


	; crer calque calque_soulignement_haut_gauche
	(set! calque_soulignement_haut_gauche (car (gimp-layer-new img width_image height_image 1 "calque_soulignement_haut_gauche" 100 0)))	

	; ajouter le calque calque_soulignement_haut_gauche
	(gimp-image-insert-layer img calque_soulignement_haut_gauche 0 -1)	
	
	
	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_Soulignement_logo_haut_gauche)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background Couleur_fond)	
	
	; points slection
	(aset *array2_4_points* 0 (round (- width_image (/ width_logo 2))))	; x0
	(aset *array2_4_points* 1 (round (/ height_logo 4)))				; y0
	(aset *array2_4_points* 2 (round (* width_logo 0.4)))				; x1
	(aset *array2_4_points* 3 height_logo)								; y1		
	(aset *array2_4_points* 4 (round (* width_logo 0.3)))				; x2
	(aset *array2_4_points* 5 (* height_logo 2.2))						; y2
	(aset *array2_4_points* 6 (round (* width_logo 0.3)))				; x3
	(aset *array2_4_points* 7 (round (/ height_logo 4)))				; y3	
	
	; slection
	(gimp-free-select 
		img									; image 
		8									; num-segs 
		*array2_4_points*					; segs 
		0									; operation 
		TRUE								; antialias 
		TRUE								; feather 
		1									; feather-radius
	)	
	
	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img calque_soulignement_haut_gauche)
	
	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "soulignement_haut_gauche")	
	
	; rduire la slection
	(gimp-selection-shrink img (round (/ height_logo 10)) )
	
	; agrandir la slection
	(gimp-selection-grow img (round (/ height_logo 10)) )

	; dformation de la slection
;	(script-fu-distress-selection 
;		img 
;		calque_soulignement_haut_gauche 
;		(* (+ (rand (round (/ height_logo 20))) 1) 
;		(+ (rand (round (/ height_logo 20))) 1))
;		(round (/ height_logo 10))
;		4 
;		2 
;		TRUE 
;		TRUE
;	)

	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img calque_soulignement_haut_gauche)
	
	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "soulignement_haut_gauche_arrondi")		

	; remplir la slection de couleur PP	
	(gimp-bucket-fill 
		calque_soulignement_haut_gauche	; drawable 
		0								; fill-mode 
		0								; paint-mode 
		100								; opacity 
		0								; threshold 
		TRUE							; sample-merged 
		0								; x 
		0								; y
	)	
	
	; ne rien slectionner
	(gimp-selection-none img)	
	
	; mode superposer
	(gimp-layer-set-mode calque_soulignement_haut_gauche 5)
	
	; opacit du calque
	(gimp-layer-set-opacity calque_soulignement_haut_gauche 80)	
	




	
	
	
; calque calque_soulignement_bas_droite *******************************************************************************
	


	; crer calque calque_soulignement_bas_droite
	(set! calque_soulignement_bas_droite (car (gimp-layer-new img width_image height_image 1 "calque_soulignement_bas_droite" 100 0)))	

	; ajouter le calque calque_soulignement_bas_droite
	(gimp-image-insert-layer img calque_soulignement_bas_droite 0 -1)	
	
	
	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_Soulignement_logo_bas_droit)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background Couleur_fond)	
	
	; points slection
	(aset *array3_4_points* 0 (round (- width_image (/ width_logo 2))))		; x0
	(aset *array3_4_points* 1 (round (/ height_logo 4)))					; y0
	(aset *array3_4_points* 2 (+ (round (* width_logo 0.4)) width_logo))	; x1
	(aset *array3_4_points* 3 (+ height_logo height_logo))					; y1		
	(aset *array3_4_points* 4 (round (* width_logo 0.3)))					; x2
	(aset *array3_4_points* 5 (* height_logo 2.2))							; y2
	(aset *array3_4_points* 6 (round (- width_image (/ width_logo 2))))		; x3
	(aset *array3_4_points* 7 (round (* height_logo 2.6)))					; y3	
	
	; slection
	(gimp-free-select 
		img									; image 
		8									; num-segs 
		*array3_4_points*					; segs 
		0									; operation 
		TRUE								; antialias 
		TRUE								; feather 
		1									; feather-radius
	)	
	
	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img calque_soulignement_bas_droite)
	
	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "soulignement_bas_droite")	
	
	; rduire la slection
	(gimp-selection-shrink img (round (/ height_logo 10)) )
	
	; agrandir la slection
	(gimp-selection-grow img (round (/ height_logo 10)) )

	; dformation de la slection
;	(script-fu-distress-selection 
;		img 
;		calque_soulignement_bas_droite 
;		(* (+ (rand (round (/ height_logo 20))) 1) 
;		(+ (rand (round (/ height_logo 20))) 1))
;		(round (/ height_logo 10))
;		4 
;		2 
;		TRUE 
;		TRUE
;	)

	
	; sauvegarder cette slection dans un chemin
	(plug-in-sel2path 1 img calque_soulignement_bas_droite)
	
	; donner un nom au chemin
	(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "soulignement_bas_droite_arrondi")		

	; remplir la slection de couleur PP	
	(gimp-bucket-fill 
		calque_soulignement_bas_droite	; drawable 
		0								; fill-mode 
		0								; paint-mode 
		100								; opacity 
		0								; threshold 
		TRUE							; sample-merged 
		0								; x 
		0								; y
	)	
	
	; ne rien slectionner
	(gimp-selection-none img)	
	
	; mode superposer
	(gimp-layer-set-mode calque_soulignement_bas_droite 5)
	
	; opacit du calque
	(gimp-layer-set-opacity calque_soulignement_bas_droite 80)	
	
	

;; crer les signatures
	(if
		(= Signatures TRUE)
			(begin

				; calque_signature_gauche *******************************************************************************


					; modifier couleur de premier plan
					(gimp-context-set-foreground Couleur_encre_signature_gauche)
					
					; modifier couleur d'arrire plan
					(gimp-context-set-background Couleur_fond)

					; crer le calque_signature_gauche
					;                  (gimp-text-fontname image drawable x y text border antialias size size-type fontname)
					(set! calque_signature_gauche (car (gimp-text-fontname img -1 (- width_image width_total_signatures) (- height_image (/ (- height_image (round (* height_logo 2))) 2)) Texte_signature_gauche 0 TRUE Taille_Police_signature_gauche 0 Police_signature_gauche)))
					
					; donner un nom au calque
					(gimp-item-set-name calque_signature_gauche "calque_signature_gauche")
					
					; slectionner le texte
					(gimp-image-select-item img 0 calque_signature_gauche)
					
					; sauvegarder cette slection dans un chemin
					(plug-in-sel2path 1 img calque_signature_gauche)
					
					; donner un nom au chemin
					(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "Texte_signature_gauche")

					; ne rien slectionner
					(gimp-selection-none img)	
					
					; mode dodge
					(gimp-layer-set-mode calque_signature_gauche 16)
					
					; opacit du calque
					(gimp-layer-set-opacity calque_signature_gauche 70)


					


				; calque_signature_droite *******************************************************************************


					; modifier couleur de premier plan
					(gimp-context-set-foreground Couleur_encre_signature_droite)
					
					; modifier couleur d'arrire plan
					(gimp-context-set-background Couleur_fond)

					; crer le calque_signature_droite
					;                  (gimp-text-fontname image drawable x y text border antialias size size-type fontname)
					(set! calque_signature_droite (car (gimp-text-fontname img -1 (- width_image (- width_total_signatures (+ width_signature_gauche (round (* width_logo 0.02)) ))) (- height_image (/ (- height_image (round (* height_logo 2))) 2)) Texte_signature_droite 0 TRUE Taille_Police_signature_droite 0 Police_signature_droite)))
					
					; donner un nom au calque
					(gimp-item-set-name calque_signature_droite "calque_signature_droite")
					
					; slectionner le texte
					(gimp-image-select-item img 0 calque_signature_droite)
					
					; sauvegarder cette slection dans un chemin
					(plug-in-sel2path 1 img calque_signature_droite)
					
					; donner un nom au chemin
					(gimp-item-set-name (car (gimp-image-get-active-vectors img)) "Texte_signature_droite")

					; ne rien slectionner
					(gimp-selection-none img)	
					
					; mode dodge
					(gimp-layer-set-mode calque_signature_droite 16)
					
					; opacit du calque
					(gimp-layer-set-opacity calque_signature_droite 70)	

					
			)
 )	
	
	
	
; calque calque_couleur_fond *******************************************************************************
	


	; crer calque calque_couleur_fond
	(set! calque_couleur_fond (car (gimp-layer-new img width_image height_image 1 "calque_couleur_fond" 100 0)))	

	; ajouter le calque calque_couleur_fond
	(gimp-image-insert-layer img calque_couleur_fond 0 -1)	
	
	
	; modifier couleur de premier plan
	(gimp-context-set-foreground Couleur_encre_fond)
	
	; modifier couleur d'arrire plan
	(gimp-context-set-background Couleur_fond)

	; crer une slection rectangulaire
	(gimp-image-select-rectangle
		img								; image 
		0								; operation 
		0								; x 
		0								; y 
		width_image						; width 
		height_image					; height
	)

	; remplir la slection de couleur AP	
	(gimp-bucket-fill 
		calque_couleur_fond				; drawable 
		1								; fill-mode 
		0								; paint-mode 
		100								; opacity 
		0								; threshold 
		TRUE							; sample-merged 
		0								; x 
		0								; y
	)

	; descendre le calque
	(gimp-image-lower-item img calque_couleur_fond)
	(gimp-image-lower-item img calque_couleur_fond)
	(gimp-image-lower-item img calque_couleur_fond)
	(gimp-image-lower-item img calque_couleur_fond)
	(gimp-image-lower-item img calque_couleur_fond)
	(if
		(= Signatures TRUE)
			(begin	
				(gimp-image-lower-item img calque_couleur_fond)
				(gimp-image-lower-item img calque_couleur_fond)
			)
	)
	
		

		
	
	
	
;*******************************************************************************************
	
	; aplatir l'image
	(if
		(= flatten TRUE)
			(gimp-image-flatten img)
	)	

	
;*******************************************************************************************






;; Delete l'image du motif ( img_motif_texte ) ***************************************************************************

	; supprimer l'image
	(gimp-image-delete img_motif_texte)



;*************************************************************************************************************************



	
	; restaurer PP et AP
	(gimp-context-set-foreground  old-fg)
	(gimp-context-set-background old-bg)
	
	; restaurer brosse
	(gimp-context-set-brush old-brush)
	
	; restaurer interpolation
	(gimp-context-set-interpolation old_interpolation)

	; ne rien slectionner
	(gimp-selection-none img)
	
	; afficher l'image
	(gimp-display-new img)

	; End undo group.
	(gimp-image-undo-group-end img)	
	


	)
		
)



(script-fu-register
	"Typography_in_Gimp_By_GimpKnowHow"
	"<Image>/File/Create/Logos/Typography in Gimp..."
	"Logo"
	"samj"
	"samj"
	"2010-06-18"
	""
	SF-STRING "Tekst tła" "GIMP-Polskie Forum Użytkowników GIMP-a * www.gimpuj.info * "
	SF-FONT "Font background" "Arial Heavy" ; Serif Bold
	SF-COLOR "Color ink background" '(107 107 107) ; gris 
	SF-ADJUSTMENT "Odstępy tekstu tła" '(1 0.6 1.5 0.05 0.1 2 1)
	SF-STRING "Text Logo (co najmniej 3 znaki)" "Typography"
	SF-FONT "Czcionka logo" "Arial Heavy" ; Serif Bold
	SF-COLOR "Kolor logo" '(255 255 255) ; blanc	
	SF-ADJUSTMENT "Font Size logo [pixels]" '(100 48 480 1 10 0 1)
	SF-STRING "Tekst podpisu lewy (co najmniej 1 znak)" "BY"
	SF-FONT "Font left" "Arial Heavy" ; Serif Bold
	SF-COLOR "Color ink left" '(210 248 78) ; jaune vert 	
	SF-STRING "Tekst podpisu prawy (przynajmniej 1 znak)" "LES AUTEURS"
	SF-FONT "Font right" "Arial Heavy" ; Serif Bold
	SF-COLOR "Color ink right" '(179 56 159) ; violet
	SF-COLOR "Kolor podkreślenia logo lewy górny" '(192 231 58) ; vert
	SF-COLOR "Kolor podkreślenia logo prawy dolny" '(212 115 186) ; violet clair
	SF-TOGGLE "Utworzyć podpisy" TRUE
	SF-TOGGLE "Flatten" TRUE
	
)


; FIN du script